<?php
/** @var $gmDB
 * @var  $gmCore
 * @var  $gmGallery
 * @var  $module
 * @var  $settings
 * @var  $terms
 * @var  $gmedia
 * @var  $is_bot
 * @var  $query
 **/

global $wp;
$settings    = array_merge($settings, array('url'           => add_query_arg($_SERVER['QUERY_STRING'], '', home_url($wp->request)),
                                            'module_dirurl' => $module['url'],
                                            'ajax_actions'  => array('comments' => array('action' => 'load_comments',
                                                                                         'data'   => array('post_id' => 0)
                                            )
                                            ),
));
$allsettings = array_merge($module['options'], $settings);

$base_url_host = parse_url($gmCore->upload['url'], PHP_URL_HOST);
$term_url      = remove_query_arg('gm' . $id);

$gmedias = $gmDB->get_gmedias($query);
if(empty($gmedias)){
    echo GMEDIA_GALLERY_EMPTY;

    return;
}
foreach($gmedias as $gmkey => $item){
    gmedia_item_more_data($item);

    $gps       = str_replace(' ', '', $item->gps);
    $attr_data = array('id'      => $item->ID,
                       'post_id' => $item->post_id,
                       'ratio'   => $item->img_ratio,
                       'mtype'   => $item->type,
                       'ext'     => $item->ext,
                       'gps'     => $gps,
                       'views'   => empty($item->meta['views'][0])? 0 : (int)$item->meta['views'][0],
                       'likes'   => empty($item->meta['likes'][0])? 0 : (int)$item->meta['likes'][0],
    );

    if(!empty($allsettings['commentsEnabled'])){
        $cc = 0;
        if($item->post_id){
            $cc = wp_count_comments($item->post_id);
            $cc = $cc->approved;
        }
        $attr_data['cc'] = $cc;
    }

    if(!empty($allsettings['share_post_link'])){
        $attr_data['post_link'] = get_permalink($item->post_id);
    }

    if(!empty($allsettings['show_download_button'])){
        $attr_data['download'] = 'image' == $item->type? $item->url_original : $item->url;
        $attr_data['filename'] = $item->gmuid;
    }

    $link_target = '';
    if($item->link){
        if($allsettings['link_target']){
            $link_target = $allsettings['link_target'];
        } else{
            $url_host = parse_url($item->link, PHP_URL_HOST);
            if($url_host == $base_url_host || empty($url_host)){
                $link_target = '_self';
            } else{
                $link_target = '_blank';
            }
        }
        if(isset($item->meta['link_target'][0])){
            $link_target = $item->meta['link_target'][0];
        }

        $attr_data['link']   = $item->link;
        $attr_data['target'] = $link_target;
    }

    $attr_data_html = '';
    foreach($attr_data as $key => $val){
        $attr_data_html .= " data-{$key}='" . esc_attr($val) . "'";
    }
    $item->attr_data_html = $attr_data_html;

    ob_start();

    if(!empty($allsettings['show_author'])){
        $author['name']       = get_the_author_meta('display_name', $item->author);
        $author['posts_link'] = get_author_posts_url($item->author);
        $avatar_img           = get_avatar($item->author, 30);
        if(preg_match("/src=['\"](.*?)['\"]/i", $avatar_img, $matches)){
            $author['avatar'] = $matches[1];
        }
        ?>
        <div class="gmCubik_author_region gmCubik_section">
            <div class="gmCubik_author_info">
                <a class="gmCubik_avatar" href="<?php echo $author['posts_link']; ?>"><img src="<?php echo $author['avatar']; ?>"></a>
                <a class="gmCubik_actor" href="<?php echo $author['posts_link']; ?>"><?php echo $author['name']; ?></a>
            </div>
        </div>
        <?php
    }

    echo '<div class="gmCubik_actions_region gmCubik_section"></div>';

    if((int)$allsettings['show_title']){
        $title = $item->title;
        if($item->link){
            $title = "<a href='{$item->link}' target='{$link_target}'>" . ($title? $title : $item->gmuid) . '</a>';
        }
    } else{
        $title = '';
    }
    if($title || $item->description){
        ?>
        <div class="gmCubik_description_region">
            <div class="gmCubik_description">
                <div class="gmCubik_title"><?php echo $title; ?></div>
                <div class="gmCubik_text"><?php echo str_replace(array("\r\n", "\r", "\n"), '', wpautop($item->description)); ?></div>
            </div>
        </div>
        <?php
    }

    $tags = array();
    if((int)$allsettings['show_tags'] && $item->tags){
        foreach($item->tags as $_term){
            $url    = add_query_arg(array("gm{$id}" => array('tag__in' => $_term->term_id)), $term_url);
            $tags[] = '<a href="' . urldecode($url) . '" class="gmCubik_tag">#' . $_term->name . '</a>';
        }
    }

    $categories = array();
    if((int)$allsettings['show_categories'] && $item->categories){
        foreach($item->categories as $_term){
            $url          = add_query_arg(array("gm{$id}" => array('category__in' => $_term->term_id)), $term_url);
            $categories[] = '<a href="' . urldecode($url) . '" class="gmCubik_cat">' . $_term->name . '</a>';
        }
    }

    $albums = array();
    if((int)$allsettings['show_albums'] && $item->album){
        foreach($item->album as $_term){
            $url      = add_query_arg(array("gm{$id}" => array('album__in' => $_term->term_id)), $term_url);
            $albums[] = '<a href="' . urldecode($url) . '" class="gmCubik_alb">' . $_term->name . '</a>';
        }
    }

    if(count($tags)){
        ?>
        <div class="gmCubik_terms_region">
            <div class="gmCubik_terms_container"><?php echo implode(' ', $tags); ?></div>
        </div>
        <?php
    }
    ?>
    <div class="gmCubik_details_region">
        <div class="gmCubik_item_details">
            <div class="gmCubik_badges">
                <div class="gmCubik_badges__column">
                    <div class="gmCubik_badges__label"><?php echo $allsettings['views_text']; ?></div>
                    <div class="gmCubik_badges__count mfp-views-count"><?php echo $attr_data['views']; ?></div>
                </div>
                <div class="gmCubik_badges__column">
                    <div class="gmCubik_badges__label"><?php echo $allsettings['likes_text']; ?></div>
                    <div class="gmCubik_badges__count mfp-likes-count"><?php echo $attr_data['likes']; ?></div>
                </div>
                <?php if(!empty($allsettings['commentsEnabled'])){ ?>
                    <div class="gmCubik_badges__column">
                        <div class="gmCubik_badges__label"><?php echo $allsettings['comments_text']; ?></div>
                        <div class="gmCubik_badges__count mfp-comments-count"><?php echo $attr_data['cc']; ?></div>
                    </div>
                <?php } ?>
                <div class="gmCubik_clearfix"></div>
            </div>
            <?php
            $exif = $gmCore->metadata_info($item->ID);
            if('image' === $item->type && !empty($exif)){
                $details                    = array();
                $details['model']           = empty($exif['model'])? '' : $exif['model']['value'];
                $details['lens']            = empty($exif['lens'])? '' : $exif['lens']['value'];
                $details['camera_settings'] = array('focallength' => empty($exif['focallength'])? (empty($exif['focallength35'])? '' : $exif['focallength35']['value']) : $exif['focallength']['value'],
                                                    'aperture'    => empty($exif['aperture'])? '' : str_replace('f', 'ƒ', $exif['aperture']['value']),
                                                    'exposure'    => empty($exif['exposure'])? '' : $exif['exposure']['value'],
                                                    'iso'         => empty($exif['iso'])? '' : 'ISO ' . $exif['iso']['value']
                );
                $details['camera_settings'] = array_filter($details['camera_settings']);
                $is_details                 = array_filter($details);
                if(!empty($is_details)){
                    ?>
                    <div class="gmCubik_exif gmCubik_section">
                        <div class="gmCubik_label"><?php echo $details['model']; ?></div>
                        <div class="gmCubik_label small"><?php echo $details['lens']; ?></div>
                        <div class="gmCubik_label small gmCubik_camera_settings"><?php echo implode('<span class="gmCubik_sep">/</span>', $details['camera_settings']); ?></div>
                    </div>
                    <?php
                }
            }

            $details                                  = array();
            $details[ __('Album', 'grand-media') ]    = implode(', ', $albums);
            $cat_key                                  = (count($categories) > 1)? __('Categories', 'grand-media') : __('Category', 'grand-media');
            $details[ $cat_key ]                      = implode(', ', $categories);
            $details[ __('Taken', 'grand-media') ]    = empty($exif['created_timestamp'])? '' : date_i18n(get_option('date_format'), $exif['created_timestamp']['value']);
            $details[ __('Uploaded', 'grand-media') ] = date_i18n(get_option('date_format'), strtotime($item->date));
            $details                                  = array_filter($details);
            if(count($details)){
                ?>
                <div class="gmCubik_other_metadata gmCubik_section">
                    <table class="gmCubik_other_metadata_table">
                        <?php foreach($details as $key => $value){ ?>
                            <tr class="gmCubik_metarow_<?php echo sanitize_key($key); ?>">
                                <td class="gmCubik_metadata_key"><?php echo ucwords($key); ?></td>
                                <td class="gmCubik_metadata_value"><?php echo $value; ?></td>
                            </tr>
                        <?php } ?>
                    </table>
                </div>
                <?php
            } ?>
        </div>
    </div>
    <?php
    if(!empty($allsettings['show_location']) && $gps){
        ?>
        <div class="gmCubik_location">
            <div class="gmCubik_mapbox"><?php echo "<a href='https://www.google.com/maps/place/{$gps}' target='_blank'>https://www.google.com/maps/place/{$gps}</a>"; ?></div>
        </div>
        <?php
    }

    $item->details_html = ob_get_contents();
    ob_end_clean();

    $gmedias[$gmkey] = $item;
}
reset($gmedias);
?>
    <div class="gmCubik noLightbox">
        <div class="gmCubik_thumbsContainer">
            <div class="gmCubik_thumbsWrapper">
                <?php
                $gridSize = $allsettings['thumbCols'] * $allsettings['thumbRows'];
                for($i = 1; $i <= 6; $i ++){
                    echo "<div class='gmCubik_face gmCubik_side-{$i}'><div class='gmCubik_faceContainer'><div class='gmCubik_faceWrapper'>";
                    for($j = 1; $j <= $gridSize; $j ++){
                        $item = array_shift($gmedias);
                        if(!$item){
                            break;
                        }
                        ?>
                        <div class="gmCubik_thumb gmCubik_thumbLoader<?php echo ($item->type !== 'image')? ' mfp-iframe' : ''; ?>"<?php echo $item->attr_data_html; ?>>
                            <a class="gmCubik_thumbImg" href="<?php echo $item->url; ?>" title="<?php echo esc_attr($item->title); ?>"><img src="<?php echo $item->url_thumb; ?>" data-src="<?php echo $item->url_web; ?>" alt="<?php echo esc_attr($item->alttext); ?>"></a>
                            <script type="text/html" class="gmCubik_thumbDetails"><?php echo $item->details_html; ?></script>
                        </div>
                        <?php
                    }
                    echo '</div></div></div>';
                }
                $gmCount = count($gmedias);
                if($gmCount){
                    echo '<div class="gmCubik_noplace">';
                    for($i = 0; $i < $gmCount; $i ++){
                        $item = array_shift($gmedias);
                        if(!$item){
                            break;
                        }
                        ?>
                        <div class="gmCubik_thumb<?php echo ($item->type !== 'image')? ' mfp-iframe' : ''; ?>"<?php echo $item->attr_data_html; ?>>
                            <a class="gmCubik_thumbImg" href="<?php echo $item->url; ?>" title="<?php echo esc_attr($item->title); ?>"><img data-src="<?php echo $item->url_web; ?>" alt="<?php echo esc_attr($item->alttext); ?>"></a>
                            <script type="text/html" class="gmCubik_thumbDetails"><?php echo $item->details_html; ?></script>
                        </div>
                        <?php
                    }
                    echo '</div>';
                }
                ?>
            </div>
        </div>
    </div>

<?php
/* Dynamic CSS */
$mfp_id  = "#mfp_gm_{$id}";
$mfp_css = '';
if(isset($settings['lightboxControlsColor'])){
    $mfp_css .= "
{$mfp_id} .mfp-arrow-right:after,
{$mfp_id} .mfp-arrow-right .mfp-a {border-left-color:#{$settings['lightboxControlsColor']};}
{$mfp_id} .mfp-arrow-left:after,
{$mfp_id} .mfp-arrow-left .mfp-a {border-right-color:#{$settings['lightboxControlsColor']};}
{$mfp_id} .mfp-close,
{$mfp_id} .mfp-comments,
{$mfp_id} .mfp-likes,
{$mfp_id} .mfp-details,
{$mfp_id} .mfp-share {color:#{$settings['lightboxControlsColor']};}
{$mfp_id} .mfp-preloader {background-color:#{$settings['lightboxControlsColor']};}";
}
if(isset($settings['lightboxTitleColor'])){
    $mfp_css .= "
{$mfp_id} .mfp-title,
{$mfp_id} .mfp-counter {color:#{$settings['lightboxTitleColor']};}";
}
if(isset($settings['lightboxTextColor'])){
    $mfp_css .= "
{$mfp_id} .mfp-description {color:#{$settings['lightboxTextColor']};}";
}
if(isset($settings['lightboxBGColor'])){
    $mfp_css .= "
{$mfp_id}_bg.mfp-bg {background-color:#{$settings['lightboxBGColor']};}";
}
if(isset($settings['lightboxBGAlpha'])){
    $alpha = $settings['lightboxBGAlpha'] / 100;
    $mfp_css .= "
{$mfp_id}_bg.mfp-bg {opacity:{$alpha};}
{$mfp_id}_bg.mfp-zoom-in.mfp-bg {opacity:0}
{$mfp_id}_bg.mfp-zoom-in.mfp-ready.mfp-bg {opacity:{$alpha};}
{$mfp_id}_bg.mfp-zoom-in.mfp-removing.mfp-bg {opacity:0}";
}
if(isset($settings['sidebarBGColor'])){
    $mfp_css .= "
{$mfp_id} .mfp-comments-content {background-color:#{$allsettings['commentsBGColor']};}
{$mfp_id} .mfp-details-content {background-color:#{$allsettings['commentsBGColor']};}";
}
if($mfp_css){
    $settings['mfp_css'] = $mfp_css;
}

$cssid = "#GmediaGallery_{$id}";
$dcss  = '';
if(isset($settings['thumbCols'])){
    $width = 100 / $settings['thumbCols'];
    $dcss .= "
{$cssid} .gmCubik_face .gmCubik_thumb {width:{$width}%;}";
}
if(isset($settings['thumbRows'])){
    $height = 100 / $settings['thumbRows'];
    $dcss .= "
{$cssid} .gmCubik_face .gmCubik_thumb {height:{$height}%;}";
}
if(isset($settings['thumbsSpacing'])){
    $correction = 0 - $settings['thumbsSpacing'];
    $dcss .= "
{$cssid} .gmCubik_faceWrapper {left:{$correction}px;top:{$correction}px;}
{$cssid} .gmCubik_thumbImg {left:{$settings['thumbsSpacing']}px;top:{$settings['thumbsSpacing']}px;}";
}
if(isset($settings['faceAlpha']) || isset($settings['faceBG'])){
    if((int)$allsettings['faceAlpha']){
        $rgb   = implode(',', $gmCore->hex2rgb($allsettings['faceBG']));
        $alpha = $allsettings['faceAlpha'] / 100;
        $dcss .= "
{$cssid} .gmCubik_face {background-color:rgba({$rgb},{$alpha}); border-color:#{$allsettings['faceBG']};}";
    } else{
        $dcss .= "
{$cssid} .gmCubik_face {background-color:transparent; border:none;}";
    }
}
if(isset($settings['facePadding'])){
    $dcss .= "
{$cssid} .gmCubik_face {padding:{$allsettings['facePadding']}px;}";
}
if(isset($settings['faceMargin'])){
    $neg = 0 - $allsettings['faceMargin'];
    $pos = 0 + $allsettings['faceMargin'];
    $dcss .= "
{$cssid} .gmCubik_thumbsWrapper .gmCubik_side-1 { -webkit-transform:translateY(-50%) translateY({$neg}px) rotateX(90deg); -moz-transform:translateY(-50%) translateY({$neg}px) rotateX(90deg); transform:translateY(-50%) translateY({$neg}px) rotateX(90deg); }
{$cssid} .gmCubik_thumbsWrapper .gmCubik_side-2 { -webkit-transform:rotateY(-90deg) translateX(50%) translateX({$pos}px) rotateY(90deg); -moz-transform:rotateY(-90deg) translateX(50%) translateX({$pos}px) rotateY(90deg); transform:rotateY(-90deg) translateX(50%) translateX({$pos}px) rotateY(90deg); }
{$cssid} .gmCubik_thumbsWrapper .gmCubik_side-3 { -webkit-transform:translateX(50%) translateX({$pos}px) rotateY(90deg); -moz-transform:translateX(50%) translateX({$pos}px) rotateY(90deg); transform:translateX(50%) translateX({$pos}px) rotateY(90deg); }
{$cssid} .gmCubik_thumbsWrapper .gmCubik_side-4 { -webkit-transform:rotateY(90deg) translateX(50%) translateX({$pos}px) rotateY(90deg); -moz-transform:rotateY(90deg) translateX(50%) translateX({$pos}px) rotateY(90deg); transform:rotateY(90deg) translateX(50%) translateX({$pos}px) rotateY(90deg); }
{$cssid} .gmCubik_thumbsWrapper .gmCubik_side-5 { -webkit-transform:translateX(-50%) translateX({$neg}px) rotateY(-90deg); -moz-transform:translateX(-50%) translateX({$neg}px) rotateY(-90deg); transform:translateX(-50%) translateX({$neg}px) rotateY(-90deg); }
{$cssid} .gmCubik_thumbsWrapper .gmCubik_side-6 { -webkit-transform:translateY(50%) translateY({$pos}px) rotateX(-90deg) rotate(180deg); -moz-transform:translateY(50%) translateY({$pos}px) rotateX(-90deg) rotate(180deg); transform:translateY(50%) translateY({$pos}px) rotateX(-90deg) rotate(180deg); }";
}
if(isset($settings['thumbAlpha']) || isset($settings['thumbAlphaHover'])){
    $alpha  = $allsettings['thumbAlpha'] / 100;
    $alpha2 = $allsettings['thumbAlphaHover'] / 100;
    $dcss .= "
{$cssid} .gmCubik_thumbImg {opacity:{$alpha};}
{$cssid} .gmCubik_thumbImg:hover {opacity:{$alpha2};}";
}
if((int)$allsettings['bgAlpha'] > 0){
    $rgb   = implode(',', $gmCore->hex2rgb($allsettings['bgColor']));
    $alpha = $allsettings['bgAlpha'] / 100;
    $dcss .= "
{$cssid} .gmCubik {background-color:rgba({$rgb},{$alpha});}";
}
if($dcss){
    $customCSS = $dcss . $customCSS;
}

if(!$is_bot){
    if($shortcode_raw){
        echo '<pre style="display:none">';
    }
    ?>
    <script type="text/javascript">
      document.addEventListener('DOMContentLoaded', function(){
        jQuery(function() {
            var settings = <?php echo json_encode($settings); ?>;
            jQuery('#GmediaGallery_<?php echo esc_attr( $id ); ?>').gmCubik([settings]);
        });
      });
    </script><?php
    if($shortcode_raw){
        echo '</pre>';
    }
}

